/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.34 Revision 1.62
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.34 2005/12/30 18:36:39 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.62 2009/09/06 22:54:58 robbat2 Exp $
4# 4#
5# Description: This eclass is used as a central eclass for accessing kernel
6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out
9# using additional eclasses.
10#
11# Maintainer: John Mylchreest <johnm@gentoo.org> 5# Original author: John Mylchreest <johnm@gentoo.org>
12# Copyright 2004 Gentoo Linux 6# Maintainer: kernel-misc@gentoo.org
13# 7#
14# Please direct your bugs to the current eclass maintainer :) 8# Please direct your bugs to the current eclass maintainer :)
9
10# @ECLASS: linux-info.eclass
11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
15 24
16# A Couple of env vars are available to effect usage of this eclass 25# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 26# These are as follows:
18# 27
19# Env Var Option Description 28# @ECLASS-VARIABLE: KERNEL_DIR
20# KERNEL_DIR <string> The directory containing kernel the target kernel 29# @DESCRIPTION:
21# sources. 30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
22# CONFIG_CHECK <string> a list of .config options to check for before 35# A string containing a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR" 36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
24# You can also check that an option doesn't exist by 40# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!). 41# prepending it with an exclamation mark (!).
42#
26# ie: CONFIG_CHECK="!MTRR" 43# e.g.: CONFIG_CHECK="!MTRR"
27# ERROR_CFG <string> The error message to display when the above check 44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
28# fails. <CFG> should reference the appropriate option 58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
29# as above. ie: ERROR_MTRR="MTRR exists in the .config 59#
30# but shouldn't!!" 60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
31# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from 61
32# the kernel makefile. This contains the directory 62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
33# which is to be used as the kernel object directory. 65# which is to be used as the kernel object directory.
34 66
35# There are also a couple of variables which are set by this, and shouldn't be 67# There are also a couple of variables which are set by this, and shouldn't be
36# set by hand. These are as follows: 68# set by hand. These are as follows:
37# 69
38# Env Var Option Description 70# @ECLASS-VARIABLE: KV_FULL
39# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1 71# @DESCRIPTION:
40# KV_MAJOR <integer> The kernel major version. ie: 2 72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
41# KV_MINOR <integer> The kernel minor version. ie: 6 73
42# KV_PATCH <integer> The kernel patch version. ie: 9 74# @ECLASS-VARIABLE: KV_MAJOR
43# KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo 75# @DESCRIPTION:
44# KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm 76# A read-only variable. It's an integer containing the kernel major version. ie: 2
45# KV_DIR <string> The kernel source directory, will be null if 77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
46# KERNEL_DIR is invalid. 97# KERNEL_DIR is invalid.
47# KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless 98
48# koutput is used. This should be used for referencing 99# @ECLASS-VARIABLE: KV_OUT_DIR
49# .config. 100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
50 107
51# And to ensure all the weirdness with crosscompile 108# And to ensure all the weirdness with crosscompile
52inherit toolchain-funcs versionator 109inherit toolchain-funcs versionator
53 110
54EXPORT_FUNCTIONS pkg_setup 111EXPORT_FUNCTIONS pkg_setup
112
113DEPEND="kernel_linux? ( virtual/linux-sources )"
114RDEPEND=""
55 115
56# Overwritable environment Var's 116# Overwritable environment Var's
57# --------------------------------------- 117# ---------------------------------------
58KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}" 118KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
59 119
63case ${ARCH} in 123case ${ARCH} in
64 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 124 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
65 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 125 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
66esac 126esac
67 127
68# These are legacy wrappers for toolchain-funcs. 128# @FUNCTION: set_arch_to_kernel
69# I dont like them here, but oh well. 129# @DESCRIPTION:
130# Set the env ARCH to match what the kernel expects.
70set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; } 131set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
132# @FUNCTION: set_arch_to_portage
133# @DESCRIPTION:
134# Set the env ARCH to match what portage expects.
71set_arch_to_portage() { export ARCH="$(tc-arch)"; } 135set_arch_to_portage() { export ARCH=$(tc-arch); }
72 136
73# qeinfo "Message" 137# qeinfo "Message"
74# ------------------- 138# -------------------
75# qeinfo is a quiet einfo call when EBUILD_PHASE 139# qeinfo is a quiet einfo call when EBUILD_PHASE
76# should not have visible output. 140# should not have visible output.
91qeerror() { qout eerror "${@}" ; } 155qeerror() { qout eerror "${@}" ; }
92 156
93# File Functions 157# File Functions
94# --------------------------------------- 158# ---------------------------------------
95 159
96# getfilevar accepts 2 vars as follows: 160# @FUNCTION: getfilevar
97# getfilevar <VARIABLE> <CONFIGFILE> 161# @USAGE: variable configfile
98 162# @RETURN: the value of the variable
163# @DESCRIPTION:
164# It detects the value of the variable defined in the file configfile. This is
165# done by including the configfile, and printing the variable with Make.
166# It WILL break if your makefile has missing dependencies!
99getfilevar() { 167getfilevar() {
100local ERROR workingdir basefname basedname myARCH="${ARCH}" 168local ERROR basefname basedname myARCH="${ARCH}"
101 ERROR=0 169 ERROR=0
102 170
103 [ -z "${1}" ] && ERROR=1 171 [ -z "${1}" ] && ERROR=1
104 [ ! -f "${2}" ] && ERROR=1 172 [ ! -f "${2}" ] && ERROR=1
105 173
107 then 175 then
108 echo -e "\n" 176 echo -e "\n"
109 eerror "getfilevar requires 2 variables, with the second a valid file." 177 eerror "getfilevar requires 2 variables, with the second a valid file."
110 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 178 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
111 else 179 else
112 workingdir="${PWD}"
113 basefname="$(basename ${2})" 180 basefname="$(basename ${2})"
114 basedname="$(dirname ${2})" 181 basedname="$(dirname ${2})"
115 unset ARCH 182 unset ARCH
116 183
117 cd "${basedname}" 184 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
118 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 185 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
119 make ${BUILD_FIXES} -s -f - e 2>/dev/null
120 cd "${workingdir}"
121 186
122 ARCH=${myARCH} 187 ARCH=${myARCH}
123 fi 188 fi
124} 189}
125 190
191# @FUNCTION: getfilevar_noexec
192# @USAGE: variable configfile
193# @RETURN: the value of the variable
194# @DESCRIPTION:
195# It detects the value of the variable defined in the file configfile.
196# This is done with sed matching an expression only. If the variable is defined,
197# you will run into problems. See getfilevar for those cases.
198getfilevar_noexec() {
199 local ERROR basefname basedname mycat myARCH="${ARCH}"
200 ERROR=0
201 mycat='cat'
202
203 [ -z "${1}" ] && ERROR=1
204 [ ! -f "${2}" ] && ERROR=1
205 [ "${2#.gz}" != "${2}" ] && mycat='zcat'
206
207 if [ "${ERROR}" = 1 ]
208 then
209 echo -e "\n"
210 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
211 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
212 else
213 ${mycat} "${2}" | \
214 sed -n \
215 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
216 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
217 s,[[:space:]]*\$,,g ;
218 p
219 }"
220 fi
221}
222
223
224# @FUNCTION: linux_config_src_exists
225# @RETURN: true or false
226# @DESCRIPTION:
227# It returns true if .config exists in a build directory otherwise false
228linux_config_src_exists() {
229 [ -s "${KV_OUT_DIR}/.config" ]
230}
231
232# @FUNCTION: linux_config_bin_exists
233# @RETURN: true or false
234# @DESCRIPTION:
235# It returns true if .config exists in /proc, otherwise false
236linux_config_bin_exists() {
237 [ -s "/proc/config.gz" ]
238}
239
240# @FUNCTION: linux_config_exists
241# @RETURN: true or false
242# @DESCRIPTION:
243# It returns true if .config exists otherwise false
244#
245# This function MUST be checked before using any of the linux_chkconfig_*
246# functions.
247linux_config_exists() {
248 linux_config_src_exists || linux_config_bin_exists
249}
250
251# @FUNCTION: require_configured_kernel
252# @DESCRIPTION:
253# This function verifies that the current kernel is configured (it checks against the existence of .config)
254# otherwise it dies.
255require_configured_kernel() {
256 if ! linux_config_src_exists; then
257 qeerror "Could not find a usable .config in the kernel source directory."
258 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
259 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
260 qeerror "it points to the necessary object directory so that it might find .config."
261 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
262 fi
263}
264
265# @FUNCTION: linux_chkconfig_present
266# @USAGE: option
267# @RETURN: true or false
268# @DESCRIPTION:
269# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
270# If linux_config_exists returns false, the results of this are UNDEFINED. You
271# MUST call linux_config_exists first.
126linux_chkconfig_present() { 272linux_chkconfig_present() {
127local RESULT 273local RESULT
274 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
275 local config
276 config="${KV_OUT_DIR}/.config"
277 [ ! -f "${config}" ] && config="/proc/config.gz"
128 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 278 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
129 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 279 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
130} 280}
131 281
282# @FUNCTION: linux_chkconfig_module
283# @USAGE: option
284# @RETURN: true or false
285# @DESCRIPTION:
286# It checks that CONFIG_<option>=m is present in the current kernel .config
287# If linux_config_exists returns false, the results of this are UNDEFINED. You
288# MUST call linux_config_exists first.
132linux_chkconfig_module() { 289linux_chkconfig_module() {
133local RESULT 290local RESULT
291 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
292 local config
293 config="${KV_OUT_DIR}/.config"
294 [ ! -f "${config}" ] && config="/proc/config.gz"
134 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 295 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
135 [ "${RESULT}" = "m" ] && return 0 || return 1 296 [ "${RESULT}" = "m" ] && return 0 || return 1
136} 297}
137 298
299# @FUNCTION: linux_chkconfig_builtin
300# @USAGE: option
301# @RETURN: true or false
302# @DESCRIPTION:
303# It checks that CONFIG_<option>=y is present in the current kernel .config
304# If linux_config_exists returns false, the results of this are UNDEFINED. You
305# MUST call linux_config_exists first.
138linux_chkconfig_builtin() { 306linux_chkconfig_builtin() {
139local RESULT 307local RESULT
308 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
309 local config
310 config="${KV_OUT_DIR}/.config"
311 [ ! -f "${config}" ] && config="/proc/config.gz"
140 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 312 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
141 [ "${RESULT}" = "y" ] && return 0 || return 1 313 [ "${RESULT}" = "y" ] && return 0 || return 1
142} 314}
143 315
316# @FUNCTION: linux_chkconfig_string
317# @USAGE: option
318# @RETURN: CONFIG_<option>
319# @DESCRIPTION:
320# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
321# If linux_config_exists returns false, the results of this are UNDEFINED. You
322# MUST call linux_config_exists first.
144linux_chkconfig_string() { 323linux_chkconfig_string() {
324 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
325 local config
326 config="${KV_OUT_DIR}/.config"
327 [ ! -f "${config}" ] && config="/proc/config.gz"
145 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config" 328 getfilevar_noexec "CONFIG_${1}" "${config}"
146} 329}
147 330
148# Versioning Functions 331# Versioning Functions
149# --------------------------------------- 332# ---------------------------------------
150 333
151# kernel_is returns true when the version is the same as the passed version 334# @FUNCTION: kernel_is
335# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
336# @RETURN: true or false
337# @DESCRIPTION:
338# It returns true when the current kernel version satisfies the comparison against the passed version.
339# -eq is the default comparison.
152# 340#
341# @CODE
153# For Example where KV = 2.6.9 342# For Example where KV = 2.6.9
154# kernel_is 2 4 returns false 343# kernel_is 2 4 returns false
155# kernel_is 2 returns true 344# kernel_is 2 returns true
156# kernel_is 2 6 returns true 345# kernel_is 2 6 returns true
157# kernel_is 2 6 8 returns false 346# kernel_is 2 6 8 returns false
158# kernel_is 2 6 9 returns true 347# kernel_is 2 6 9 returns true
159# 348# @CODE
349
160# got the jist yet? 350# got the jist yet?
161 351
162kernel_is() { 352kernel_is() {
163 # if we haven't determined the version yet, we need too. 353 # if we haven't determined the version yet, we need to.
164 get_version; 354 get_version
165 local operator test value x=0 y=0 z=0 355 local operator test value x=0 y=0 z=0
166 356
167 case ${1} in 357 case ${1} in
168 lt) operator="-lt"; shift;; 358 lt) operator="-lt"; shift;;
169 gt) operator="-gt"; shift;; 359 gt) operator="-gt"; shift;;
186 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done; 376 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
187 test="${test}${KV_PATCH}";; 377 test="${test}${KV_PATCH}";;
188 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 378 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
189 esac 379 esac
190 done 380 done
191 381
192 [ ${test} ${operator} ${value} ] && return 0 || return 1 382 [ ${test} ${operator} ${value} ] && return 0 || return 1
193} 383}
194 384
195get_localversion() { 385get_localversion() {
196 local lv_list i x 386 local lv_list i x
205 done 395 done
206 x=${x/ /} 396 x=${x/ /}
207 echo ${x} 397 echo ${x}
208} 398}
209 399
400# @FUNCTION: get_version
401# @DESCRIPTION:
402# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
403# (if KV_FULL is already set it does nothing).
404#
405# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
406#
407# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
408# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
409# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
210get_version() { 410get_version() {
211 local kbuild_output 411 local kbuild_output
212 412
213 # no need to execute this twice assuming KV_FULL is populated. 413 # no need to execute this twice assuming KV_FULL is populated.
214 # we can force by unsetting KV_FULL 414 # we can force by unsetting KV_FULL
252 # so we better find it eh? 452 # so we better find it eh?
253 # do we pass KBUILD_OUTPUT on the CLI? 453 # do we pass KBUILD_OUTPUT on the CLI?
254 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 454 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
255 455
256 # And if we didn't pass it, we can take a nosey in the Makefile 456 # And if we didn't pass it, we can take a nosey in the Makefile
257 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 457 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
258 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 458 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
259 459
260 # And contrary to existing functions I feel we shouldn't trust the 460 # And contrary to existing functions I feel we shouldn't trust the
261 # directory name to find version information as this seems insane. 461 # directory name to find version information as this seems insane.
262 # so we parse ${KV_DIR}/Makefile 462 # so we parse ${KV_DIR}/Makefile
263 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 463 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
264 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 464 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
265 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 465 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
266 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 466 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
267 467
268 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 468 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
269 then 469 then
270 qeerror "Could not detect kernel version." 470 qeerror "Could not detect kernel version."
271 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources." 471 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
274 474
275 # and in newer versions we can also pull LOCALVERSION if it is set. 475 # and in newer versions we can also pull LOCALVERSION if it is set.
276 # but before we do this, we need to find if we use a different object directory. 476 # but before we do this, we need to find if we use a different object directory.
277 # This *WILL* break if the user is using localversions, but we assume it was 477 # This *WILL* break if the user is using localversions, but we assume it was
278 # caught before this if they are. 478 # caught before this if they are.
279 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \ 479 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
280 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}" 480 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
281 481
282 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})" 482 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
283 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}" 483 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
284 if [ -n "${KV_OUT_DIR}" ]; 484 if [ -n "${KV_OUT_DIR}" ];
285 then 485 then
286 qeinfo "Found kernel object directory:" 486 qeinfo "Found kernel object directory:"
287 qeinfo " ${KV_OUT_DIR}" 487 qeinfo " ${KV_OUT_DIR}"
288 488
289 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})" 489 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
290 fi 490 fi
291 # and if we STILL haven't got it, then we better just set it to KV_DIR 491 # and if we STILL have not got it, then we better just set it to KV_DIR
292 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}" 492 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
293 493
294 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})" 494 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
495 if linux_config_exists; then
295 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)" 496 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
296 KV_LOCAL="${KV_LOCAL//\"/}" 497 KV_LOCAL="${KV_LOCAL//\"/}"
498
499 # For things like git that can append extra stuff:
500 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
501 linux_chkconfig_builtin LOCALVERSION_AUTO &&
502 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
503 fi
297 504
298 # And we should set KV_FULL to the full expanded version 505 # And we should set KV_FULL to the full expanded version
299 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 506 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
300 507
301 qeinfo "Found sources for kernel version:" 508 qeinfo "Found sources for kernel version:"
302 qeinfo " ${KV_FULL}" 509 qeinfo " ${KV_FULL}"
303 510
304 if [ ! -s "${KV_OUT_DIR}/.config" ]
305 then
306 qeerror "Could not find a usable .config in the kernel source directory."
307 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
308 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
309 qeerror "it points to the necessary object directory so that it might find .config."
310 return 1
311 fi
312
313 return 0 511 return 0
314} 512}
315 513
514# @FUNCTION: get_running_version
515# @DESCRIPTION:
516# It gets the version of the current running kernel and the result is the same as get_version() if the
517# function can find the sources.
316get_running_version() { 518get_running_version() {
317 KV_FULL=$(uname -r) 519 KV_FULL=$(uname -r)
318 520
319 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then 521 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
320 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source) 522 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
339 541
340 542
341# ebuild check functions 543# ebuild check functions
342# --------------------------------------- 544# ---------------------------------------
343 545
546# @FUNCTION: check_kernel_built
547# @DESCRIPTION:
548# This function verifies that the current kernel sources have been already prepared otherwise it dies.
344check_kernel_built() { 549check_kernel_built() {
345 # if we haven't determined the version yet, we need too. 550 # if we haven't determined the version yet, we need to
551 require_configured_kernel
346 get_version; 552 get_version
347 553
348 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ] 554 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
349 then 555 then
350 eerror "These sources have not yet been prepared." 556 eerror "These sources have not yet been prepared."
351 eerror "We cannot build against an unprepared tree." 557 eerror "We cannot build against an unprepared tree."
358 eerror "Then please try merging this module again." 564 eerror "Then please try merging this module again."
359 die "Kernel sources need compiling first" 565 die "Kernel sources need compiling first"
360 fi 566 fi
361} 567}
362 568
569# @FUNCTION: check_modules_supported
570# @DESCRIPTION:
571# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
363check_modules_supported() { 572check_modules_supported() {
364 # if we haven't determined the version yet, we need too. 573 # if we haven't determined the version yet, we need too.
574 require_configured_kernel
365 get_version; 575 get_version
366 576
367 if ! linux_chkconfig_builtin "MODULES" 577 if ! linux_chkconfig_builtin "MODULES"
368 then 578 then
369 eerror "These sources do not support loading external modules." 579 eerror "These sources do not support loading external modules."
370 eerror "to be able to use this module please enable \"Loadable modules support\"" 580 eerror "to be able to use this module please enable \"Loadable modules support\""
371 eerror "in your kernel, recompile and then try merging this module again." 581 eerror "in your kernel, recompile and then try merging this module again."
372 die "No support for external modules in ${KV_FULL} config" 582 die "No support for external modules in ${KV_FULL} config"
373 fi 583 fi
374} 584}
375 585
586# @FUNCTION: check_extra_config
587# @DESCRIPTION:
588# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
589# the prefix ~ is not used) doesn't satisfy the directive.
376check_extra_config() { 590check_extra_config() {
377 local config negate error local_error i n
378 local temp_config die reworkmodulenames 591 local config negate die error reworkmodulenames
592 local soft_errors_count=0 hard_errors_count=0 config_required=0
379 593
380 # if we haven't determined the version yet, we need too. 594 # if we haven't determined the version yet, we need to
381 get_version; 595 get_version
382 596
597 # Determine if we really need a .config. The only time when we don't need
598 # one is when all of the CONFIG_CHECK options are prefixed with "~".
599 for config in ${CONFIG_CHECK}
600 do
601 if [[ "${config:0:1}" != "~" ]]; then
602 config_required=1
603 break
604 fi
605 done
606
607 if [[ ${config_required} == 0 ]]; then
608 # In the case where we don't require a .config, we can now bail out
609 # if the user has no .config as there is nothing to do. Otherwise
610 # code later will cause a failure due to missing .config.
611 if ! linux_config_exists; then
612 ewarn "Unable to check for the following kernel config options due"
613 ewarn "to absence of any configured kernel sources:"
614 for config in ${CONFIG_CHECK}; do
615 ewarn " - ${config#\~}"
616 done
617 ewarn "You're on your own to make sure they are set if needed."
618 return 0
619 fi
620 else
621 require_configured_kernel
622 fi
623
383 einfo "Checking for suitable kernel configuration options:" 624 einfo "Checking for suitable kernel configuration options..."
625
384 for config in ${CONFIG_CHECK} 626 for config in ${CONFIG_CHECK}
385 do 627 do
386 # if we specify any fatal, ensure we honor them 628 # if we specify any fatal, ensure we honor them
387 die=1 629 die=1
388 error=0 630 error=0
389 negate=0 631 negate=0
390 reworkmodulenames=0 632 reworkmodulenames=0
391 633
392 if [[ -z ${config//\!*} ]]; then 634 if [[ ${config:0:1} == "~" ]]; then
635 die=0
636 config=${config:1}
637 elif [[ ${config:0:1} == "@" ]]; then
638 die=0
639 reworkmodulenames=1
640 config=${config:1}
641 fi
642 if [[ ${config:0:1} == "!" ]]; then
393 negate=1 643 negate=1
394 config=${config:1} 644 config=${config:1}
395 fi 645 fi
396 if [[ -z ${config/\@*} ]]; then
397 die=2
398 reworkmodulenames=1
399 config=${config:1}
400 fi
401 if [[ -z ${config/\~*} ]]; then
402 die=0
403 config=${config:1}
404 fi
405 646
406 if [[ ${negate} == 1 ]]; then 647 if [[ ${negate} == 1 ]]; then
407 linux_chkconfig_present ${config} && error=2 648 linux_chkconfig_present ${config} && error=2
408 elif [[ ${reworkmodulenames} == 1 ]]; then 649 elif [[ ${reworkmodulenames} == 1 ]]; then
409 temp_config="${config//*:}" 650 local temp_config="${config//*:}" i n
410 config="${config//:*}" 651 config="${config//:*}"
411 if linux_chkconfig_present ${config}; then 652 if linux_chkconfig_present ${config}; then
412 for i in ${MODULE_NAMES}; do 653 for i in ${MODULE_NAMES}; do
413 n="${i//${temp_config}}" 654 n="${i//${temp_config}}"
414 [[ -z ${n//(*} ]] && \ 655 [[ -z ${n//\(*} ]] && \
415 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}" 656 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
416 done 657 done
417 error=2 658 error=2
418 fi 659 fi
419 else 660 else
420 linux_chkconfig_present ${config} || error=1 661 linux_chkconfig_present ${config} || error=1
421 fi 662 fi
422 663
423 if [[ ${die} == 0 ]]; then
424 ebegin "CONFIG_${config}"
425 eend ${error}
426 else
427 if [[ ${error} > 0 ]]; then 664 if [[ ${error} > 0 ]]; then
665 local report_func="eerror" local_error
666 local_error="ERROR_${config}"
667 local_error="${!local_error}"
668
669 if [[ -z "${local_error}" ]]; then
670 # using old, deprecated format.
428 local_error="${config}_ERROR" 671 local_error="${config}_ERROR"
429 local_error="${!local_error}" 672 local_error="${!local_error}"
673 fi
674 if [[ ${die} == 0 && -z "${local_error}" ]]; then
675 #soft errors can be warnings
676 local_error="WARNING_${config}"
677 local_error="${!local_error}"
430 if [[ -z "${local_error}" ]]; then 678 if [[ -n "${local_error}" ]] ; then
431 [[ ${error} == 1 ]] \ 679 report_func="ewarn"
432 && local_error="is not set when it should be." \
433 || local_error="should not be set. But it is."
434 local_error="CONFIG_${config}:\t ${local_error}"
435 fi 680 fi
681 fi
682
683 if [[ -z "${local_error}" ]]; then
684 [[ ${error} == 1 ]] \
685 && local_error="is not set when it should be." \
686 || local_error="should not be set. But it is."
687 local_error="CONFIG_${config}:\t ${local_error}"
688 fi
689 if [[ ${die} == 0 ]]; then
436 eerror " ${local_error}" 690 ${report_func} " ${local_error}"
691 soft_errors_count=$[soft_errors_count + 1]
692 else
693 ${report_func} " ${local_error}"
694 hard_errors_count=$[hard_errors_count + 1]
437 fi 695 fi
438 fi 696 fi
439 done 697 done
440 698
441 if [[ ${error} > 0 ]]; then 699 if [[ ${hard_errors_count} > 0 ]]; then
442 eerror "Please check to make sure these options are set correctly." 700 eerror "Please check to make sure these options are set correctly."
443 eerror "Failure to do so may cause unexpected problems." 701 eerror "Failure to do so may cause unexpected problems."
444 if [[ ${die} == 1 ]]; then
445 eerror "Once you have satisfied these options, please try merging" 702 eerror "Once you have satisfied these options, please try merging"
446 eerror "this package again." 703 eerror "this package again."
447 die "Incorrect kernel configuration options" 704 die "Incorrect kernel configuration options"
448 fi 705 elif [[ ${soft_errors_count} > 0 ]]; then
706 ewarn "Please check to make sure these options are set correctly."
707 ewarn "Failure to do so may cause unexpected problems."
708 else
709 eend 0
449 fi 710 fi
450} 711}
451 712
452check_zlibinflate() { 713check_zlibinflate() {
453 # if we haven't determined the version yet, we need too. 714 # if we haven't determined the version yet, we need to
715 require_configured_kernel
454 get_version; 716 get_version
455 717
456 # although I restructured this code - I really really really dont support it! 718 # although I restructured this code - I really really really dont support it!
457 719
458 # bug #27882 - zlib routines are only linked into the kernel 720 # bug #27882 - zlib routines are only linked into the kernel
459 # if something compiled into the kernel calls them 721 # if something compiled into the kernel calls them
466 local DEFLATE 728 local DEFLATE
467 729
468 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 730 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
469 731
470 ebegin "checking ZLIB_INFLATE" 732 ebegin "checking ZLIB_INFLATE"
471 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 733 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
472 eend $? 734 eend $?
473 [ "$?" != 0 ] && die 735 [ "$?" != 0 ] && die
474 736
475 ebegin "checking ZLIB_DEFLATE" 737 ebegin "checking ZLIB_DEFLATE"
476 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 738 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
477 eend $? 739 eend $?
478 [ "$?" != 0 ] && die 740 [ "$?" != 0 ] && die
479 741
480 local LINENO_START 742 local LINENO_START
481 local LINENO_END 743 local LINENO_END
519} 781}
520 782
521################################ 783################################
522# Default pkg_setup 784# Default pkg_setup
523# Also used when inheriting linux-mod to force a get_version call 785# Also used when inheriting linux-mod to force a get_version call
524 786# @FUNCTION: linux-info_pkg_setup
787# @DESCRIPTION:
788# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
789# to support the options specified in CONFIG_CHECK (if not null)
525linux-info_pkg_setup() { 790linux-info_pkg_setup() {
526 get_version || die "Unable to calculate Linux Kernel version" 791 get_version
792 if [[ $rc -ne 0 ]]; then
793 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
794 get_running_version
795 fi
796
797 if kernel_is 2 4; then
798 if [ "$( gcc-major-version )" -eq "4" ] ; then
799 echo
800 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
801 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
802 echo
803 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
804 ewarn "newer kernel that supports gcc-4."
805 echo
806 ewarn "Also be aware that bugreports about gcc-4 not working"
807 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
808 echo
809 epause 10
810 fi
811 fi
812
527 [ -n "${CONFIG_CHECK}" ] && check_extra_config; 813 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
528} 814}

Legend:
Removed from v.1.34  
changed lines
  Added in v.1.62

  ViewVC Help
Powered by ViewVC 1.1.20